# Enumerations

Enumeration allow for integer and OID values to be translated to their text values.

The location of the enumeration definition files is specified by `EF_PROCESSOR_SNMP_ENUM_DEFINITIONS_DIRECTORY_PATH` in the collectors configuration options. The default location is `/etc/elastiflow/snmp/enums`. Enumeration lookups must also be enabled by setting `EF_PROCESSOR_SNMP_ENUM_ENABLE` to `true`.

### Bitmap Enumerations

Bitmap enumerations are evaluated when the attribute `syntax` is `EnumBitmap`.

EXAMPLE:

```yaml
# mplsTunnelCRLDPResFlags
.1.3.6.1.2.1.10.166.3.2.10.1.5:
  0: 'PDR' # PDR
  1: 'PBS' # PBS
  2: 'CDR' # CDR
  3: 'CBS' # CBS
  4: 'EBS' # EBS
  5: 'weight' # Weight
```

### Integer Enumerations

Integer enumerations are evaluated when the attribute `syntax` is `EnumInteger` or `EnumIntegerKeepID`.

EXAMPLE:

```yaml
#ifOperStatus
.1.3.6.1.2.1.2.2.1.8:
  1: 'up' # up
  2: 'down' # down
  3: 'testing' # testing
  4: 'unknown' # unknown
  5: 'dormant' # dormant
  6: 'not present' # notPresent
  7: 'lower-layer down' # lowerLayerDown
```

### Object Identifier (OID) Enumerations

Object Identifier (OID) enumerations are evaluated when the attribute `syntax` is `EnumObjectIdentifier` or `EnumObjectIdentifierKeepOID`.

EXAMPLE:

```yaml
# hrStorageType - hrStorageTypes
.1.3.6.1.2.1.25.2.1.1: 'other' # hrStorageOther
.1.3.6.1.2.1.25.2.1.2: 'RAM' # hrStorageRam
.1.3.6.1.2.1.25.2.1.3: 'virtual memory' # hrStorageVirtualMemory
.1.3.6.1.2.1.25.2.1.4: 'fixed disk' # hrStorageFixedDisk
.1.3.6.1.2.1.25.2.1.5: 'removable disk' # hrStorageRemovableDisk
.1.3.6.1.2.1.25.2.1.6: 'floppy disk' # hrStorageFloppyDisk
.1.3.6.1.2.1.25.2.1.7: 'compact disc' # hrStorageCompactDisc
.1.3.6.1.2.1.25.2.1.8: 'RAM disk' # hrStorageRamDisk
.1.3.6.1.2.1.25.2.1.9: 'flash memory' # hrStorageFlashMemory
.1.3.6.1.2.1.25.2.1.10: 'network disk' # hrStorageNetworkDisk
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.elastiflow.com/snmpcoll/configuration/snmp-definition-files/def_enums.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
